## mingw-w64-qt6-grpc-6.8.1-1.src.tar.zst

=== examples/grpc/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

if(TARGET Qt6::Quick
        AND TARGET Qt6::QuickControls2
        AND TARGET Qt6::qtprotobufgen
        AND TARGET Qt6::qtgrpcgen)
    qt_internal_add_example(magic8ball)
    if(TARGET Qt6::ProtobufWellKnownTypes)
        qt_internal_add_example(vehicle)
    endif()
    if(QT_FEATURE_clipboard)
        qt_internal_add_example(chat)
    endif()
endif()
